#informationen_aus_xml_extrahieren.py
# -*- coding: utf-8 -*-
import argparse
from lxml import etree
import re
import os.path
import urllib2
import time
import sys
reload(sys)
sys.setdefaultencoding('utf8')

#Willkommen zu einem Teilskript des Hauptstrikpts Linux_Regesten_Download_ueber_die_REST_Schnittstelle_der_RI_Online.py.
#Ziel dieses Teilskriptes ist es ausschließlich, unter Eingabe eines vorhandenen Ordnerpfades die in diesem Ordner befindlichen
#Regesten im XML-Format in ein CSV-Skript mit '|'-Separatoren.

def informationen_extrahieren(path):
    
    file = open(os.path.dirname(os.path.abspath(__file__)) + '\\' + 'Regesten_CSV' + '\\' +  'regesten_csv'+ '_' + str(path[9:20]) +'.csv', 'w')
    #Textdatei mit Ueberschriften schreiben
    file.write('id' + '|' + 'start' + '|' + 'end' + '|'+ 'place' + '|' + 'abstract' + '|' + 'uri' + '\n')
    
    file.close
    
    print 'Folgende Informationen werden aus den Regestendateien extrahiert:'
    print 'ID, Startdatum, Enddatum, Ausstellungsort, Regestentext, URI'
    print 'Wenn Sie diese Parameter aendern wollen, geben sie den korrekten XPath zur gewuenschten Information in "informationen_aus_xml_extrahieren.py" ein."'
    os.chdir(os.path.dirname(os.path.abspath(__file__)) + '\\' + path)
    #Parsen durch XML-Dateien einzelner Regesten im Zielordner
    for filename in os.listdir(os.path.dirname(os.path.abspath(__file__))):
        doc = etree.parse(filename)
        root = doc.getroot()
        
        #Extrahieren der ID
        idno = doc.findtext('charter/chDesc/head/idno')
        
        #Extrahiern des Startdatums
        start = doc.find('charter/chDesc/head/issued/issueDate/p/dateRange').attrib['from']
        
        #Extrahieren des Enddatums
        end = doc.find('charter/chDesc/head/issued/issueDate/p/dateRange').attrib['to']

        # Extrahieren der Ortsangabe
        place = doc.find('charter/chDesc/head/issued/issuePlace/placeName')
        if place is not None:
            place = etree.tostring(place, encoding='utf-8')
            place = re.sub('\n', ' ', place)
            place = re.sub('<placeName xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">', '', place)
            place = re.sub('</placeName>', '', place)
        elif place is None:
            place = None
        
        #Extrahieren des Abstracts
        abstract = doc.find('charter/chDesc/abstract/p')
        abstract = etree.tostring(abstract, encoding = 'utf-8')
        abstract = re.sub('<p xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">', '', abstract)
        abstract = re.sub('</p>', '', abstract)
        abstract = re.sub('\n', ' ', abstract)
        
        #Extrahieren der URI
        uri = doc.findtext('teiHeader/fileDesc/sourceDesc/bibl/idno')
        
        line = ''
        
        #Textdatei fuellen      
        if place != None:
            line = idno + '|' + start + '|' + end + '|' + place + '|' + abstract + '|' + uri + '|' + '\n'
        elif place == None:
            line = idno + '|' + start + '|' + end + '|' + '[o.O.]' + '|' + abstract + '|' + uri + '|' + '\n'
            
        os.chdir('..')
        file = open(os.path.dirname(os.path.abspath(__file__)) + '\\' + 'Regesten_CSV' + '\\' + 'regesten_csv'+ '_' + str(path[9:20]) +'.csv', 'a')
    
        file.write(line.encode('utf-8'))
    
        file.close
        os.chdir(os.path.dirname(os.path.abspath(__file__)) + '\\' + path)
    
    print 'Regesten-CSV gespeichert in Regesten_CSV/regesten_csv_' + str(path[9:20]) +'.csv' + '.'
    
    return

#Anfrage nach Ordner mit Regesten
path = raw_input('Geben sie den Namen des Ordners mit ihren Regesten ein: ')

#Funktionsaufruf
informationen_extrahieren(path)