# Regesten_Download_ueber_die_REST_Schnittstelle_der_RI_Online.py
# -*- coding: utf-8 -*-
import argparse
from lxml import etree
import re
import os.path
import urllib2
import time
import sys
reload(sys)
sys.setdefaultencoding('utf8')

#Willkommen zum Hauptskript zum Herunterladen von Regesten ueber die REST-Schnittstelle der Regesta Imperii Online fuer Linux.
#Im Folgenden sind zunächst vier Funktionen definiert, um spezifische Aufgaben im Rahmen des Downloads zu erfuellen:
#1. download_collection(link) zum Herunterladen der Kollektionsuebersicht, die uns alle Regesten-URI's bereitstellt
#2. extract_links(link) beschäftigt sich mit der Extraktion dieser Links, d.h. deren Bereinigung vom XML-Format,
#um die betreffenden Regesten herunterladen zu koennen
#3. download_regests(file) ist die eigentliche Download-Funktion, die die Regesten einzeln ins XML-Format herunterlaedt.
#4. informationen_extrahieren(path) hat nichts mehr mit dem eigentlichen Download zu tun, sondern erzeugt aus den heruntergeladenen
#Regesten eine CSV-Datei (mit '|'-Separator).
#Darauf folgt eine Definition der globalen Variablen, die das Skript benutzt, konkret die Einspielung der Links aller Kollektionen
#und die Erstellung der Ordner, die die Regesten spaeter aufnehmen werden.
#der RI Online.
#Abschließend folgen die Funktionsaufrufe eingebettet in die textbasierte Nutzeroberflaeche.
#Ergebnis des abgeschlossenen Skriptes sollte ein Ordner mit den Regesten im XML-Format einzeln und eine CSV-Datei mit den Regesten
#zusammengefasst sein.

#Funktionsdefinitionen

def download_collection(link):
    #Funktion zum Download der Kollektionsuebersicht als XML-Datei
    while True:
        try:
            response = urllib2.urlopen(link)
            break
        except httplib.BadStatusLine:
            time.sleep(2)
            continue

    webContent = response.read()
    response.close()
    
    print 'Gueltige URL, Download beginnt'
    
    f = open('index.xml', 'w')
    f.write(str(webContent))
    f.close
    
    print 'URL '+ link +': Download erfolgreich, Kollektion gespeichert unter "index.xml"'
    return

def extract_links(link):
    #Funktion zur Extraktion der Links ueber die Übergabe des Kollektionen-Links
    tree = etree.parse(kollektion_link)
    root = tree.getroot()
    
    #Textdatei fuer Speicherung von Links mit collections-ID erstellen
    file = open('Regesten_Links' + '/' + 'regesten_links' + '_' + str(kollektion_link[34:45]) + '.txt', 'w')

        #Fuellen der Textdatei mit den URI's der einzelnen Regesten
    for child in root:
        file.write(child.attrib['href'] + '\n')
        file.close

    print 'Links extrahiert, gespeichert in "' + 'Regesten_Links' + '/' + 'regesten_links' + '_' + str(kollektion_link[34:45]) +  '.txt"'
    return

def download_regests(file):
    #Funktion zum Download der einzelnen Regesten aus einer Textdatei mit Regestenlinks#Download der einzelnen Regesten
    f = open(file, 'r')
    links = f.readlines()
    print "Anzahl an Regesten: " + str(len(links))
    f.close()
    name_link = links[0]
    if os.path.isdir('Regesten' + '_' + str(name_link[34:45])) == False:
        download_dir = os.mkdir('Regesten' + '_' + str(name_link[34:45]) + '/')
    for link in links:

        link = re.sub('\n', '', link)
        while True:
            try:
                response = urllib2.urlopen(link)
                webContent = response.read()
                response.close()

                f = open('Regesten' + '_' + str(name_link[34:45]) + '/' + str(link[54:]) + '.xml', 'w')
                f.write(webContent)
                f.close
                num_files = len([f for f in os.listdir('Regesten' + '_' + str(name_link[34:45]) + '/')
                                 if os.path.isfile(os.path.join('Regesten' + '_' + str(name_link[34:45]) + '/', f))])
                print str(num_files) + ' von ' + str(
                    len(links)) + ' Regesten heruntergeladen, gespeichert unter "Regesten/' + str(
                    name_link[34:45]) + '/' + str(link[54:]) + '.xml" ' + '(' + str(
                    round(num_files * 100 / (len(links)), 1)) + '%' + ')'
                time.sleep(1)
                break
            except httplib.BadStatusLine:
                time.sleep(2)
                continue

    print 'Regesten gespeichert in Ordner: ' + 'Regesten' + '_' + str(name_link[34:45])
    return

def informationen_extrahieren(path):
    #Funktion zur Extraktion von Informationen aus der Regestendatei
    file = open(os.path.dirname(os.path.abspath(__file__)) + '//' + 'Regesten_CSV' + '//' +  'regesten_csv'+ '_' + str(path[9:20]) +'.csv', 'w')
    #Textdatei mit Ueberschriften schreiben
    file.write('id' + '|' + 'start' + '|' + 'end' + '|'+ 'place' + '|' + 'abstract' + '|' + 'uri' + '\n')
    file.close
    
    os.chdir(os.path.dirname(os.path.abspath(__file__)) + '//' + path)
    #Parsen durch XML-Dateien einzelner Regesten im Zielordner
    for filename in os.listdir(os.path.dirname(os.path.abspath(__file__))):
        doc = etree.parse(filename)
        #Extrahieren der ID
        idno = doc.findtext('charter/chDesc/head/idno')
        #Extrahiern des Startdatums
        start = doc.find('charter/chDesc/head/issued/issueDate/p/dateRange').attrib['from']
        #Extrahieren des Enddatums
        end = doc.find('charter/chDesc/head/issued/issueDate/p/dateRange').attrib['to']
        # Extrahieren der Ortsangabe
        place = doc.find('charter/chDesc/head/issued/issuePlace/placeName')
        if place is not None:
            place = etree.tostring(place, encoding='utf-8')
            place = re.sub('\n', ' ', place)
            place = re.sub('<placeName xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">', '', place)
            place = re.sub('</placeName>', '', place)
        elif place is None:
            place = None
        #Extrahieren des Abstracts
        abstract = doc.find('charter/chDesc/abstract/p')
        abstract = etree.tostring(abstract, encoding = 'utf-8')
        abstract = re.sub('<p xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">', '', abstract)
        abstract = re.sub('</p>', '', abstract)
        abstract = re.sub('\n', ' ', abstract)
        #Extrahieren der URI
        uri = doc.findtext('teiHeader/fileDesc/sourceDesc/bibl/idno')
        
        line = ''
        #Textdatei fuellen      
        if place != None:
            line = idno + '|' + start + '|' + end + '|' + place + '|' + abstract + '|' + uri + '|' + '\n'
        elif place == None:
            line = idno + '|' + start + '|' + end + '|' + '[o.O.]' + '|' + abstract + '|' + uri + '|' + '\n'

        os.chdir('..')
        file = open(os.path.dirname(os.path.abspath(__file__)) + '//' + 'Regesten_CSV' + '//' + 'regesten_csv'+ '_' + str(path[9:20]) +'.csv', 'a')
        file.write(line.encode('utf-8'))
        file.close
        os.chdir(os.path.dirname(os.path.abspath(__file__)) + '//' + path)
    print 'Regesten-CSV gespeichert in Regesten_CSV/regesten_csv_' + str(path[9:20]) +'.csv' + '.'
    return


#Variablendefinition

f = open('kollektionen_links.txt', 'r')
kollektionen_links = f.readlines()
Names = []
Links = []
for x in kollektionen_links:
    Names.append(x.split('\t')[1])
    Links.append(x.split('\t')[2])
f.close()
Links = [re.sub('\n', '', line) for line in Links]

#Ordner anlegen
if os.path.isdir('Regesten_Links') == False:
    csv_dir = os.mkdir('Regesten_Links')
    
if os.path.isdir('Regesten_CSV') == False:
    csv_dir = os.mkdir('Regesten_CSV')


#Start und Auflistung der Kollektionen
print 'Willkommen. Dieses Skript ist dazu gedacht, sich Regesten-Kollektionen ueber die REST-Schnittstelle der Regesta Imperii Online herunterzuladen'
kollektionen_anzeigen = raw_input('Moechten Sie sich alle verfuegbaren Kollektionen anzeigen lassen(j/n)? ')
if kollektionen_anzeigen == 'j':
    print 'Verfuegbare Kollektionen:' + '\n'
    for x in range(len(Names)):
        print Names[x] + '\t' + Links[x] + '\n'


#Funktionsaufrufe
    
#Anfrage nach der URL als Kollektion
while True:
    try:
        kollektion_link = raw_input('Geben Sie einen Link zu einer Kollektion ein: ')
        download_collection(kollektion_link)
        break
    except ValueError:
        print "Keine gueltige URL!"        

#Extraktion der Links
if os.path.isfile('index.xml') == True:
    extract_links(kollektion_link)
    
#Anfrage, ob Regesten jetzt heruntergeladen werden sollen
if os.path.isfile('Regesten_Links' + '/' + 'regesten_links' + '_' + str(kollektion_link[34:45]) + '.txt') == True:
    download_bestaetigung = raw_input('Moechten Sie die einzelnen Regesten jetzt herunterladen(j/n)? ')
    #Wenn 'j', Download der Regesten
    if download_bestaetigung == 'j':
        download_regests('Regesten_Links' + '/' +  'regesten_links' + '_' + str(kollektion_link[34:45]) + '.txt')
        informations_extraktion = raw_input('Moechten Sie jetzt die XML-Regesten in einer CSV-Datei zusammenfassen(j/n)? ')
        if informations_extraktion == 'j':
            pfad_anfrage = raw_input('Geben sie den Namen des Ordners mit ihren Regesten ein:')
            print 'Folgende Informationen werden aus den Regestendateien extrahiert:'
            print 'ID, Startdatum, Enddatum, Ausstellungsort, Regestentext, URI'
            print 'Wenn Sie diese Parameter aendern wollen, geben sie den korrekten XPath zur gewuenschten Information in "informationen_aus_xml_extrahieren.py" ein'
            print 'und extrahieren sie ihre Informationen ueber dieses Skript'
            informationen_extrahieren(pfad_anfrage)
        elif informations_extraktion == 'n':
            print 'Wenn Sie nur Informationen extrahieren moechten, koennen sie hierzu auch das Skript "informationen_aus_xml_extrahieren.py" aufrufen'
    elif download_bestaetigung == 'n':
        print '"' + 'Regesten_Links' + '/' +  'regesten_links' + '_' + str(kollektion_link[34:45]) + '.txt' + '" ist jetzt mit Ihren Links gefuellt'
        print 'Wenn Sie nur Regesten ueber "regesten_links.txt" herunterladen moechten, koennen Sie dazu auch das Skript "regesten_herunterladen.py" benutzen'
        print 'Wenn sie Informationen aus den Regesten extrahieren wollen in eine CSV-Datei über "informationen_aus_xml_extrahieren.py", müssen sie diese zunächst herunterladen!'
print 'Auf Wiedersehen.'
